"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var DynamoDBToolboxCoreModule_1;
Object.defineProperty(exports, "__esModule", { value: true });
exports.DynamoDBToolboxCoreModule = void 0;
const common_1 = require("@nestjs/common");
const dynamodb_toolbox_1 = require("dynamodb-toolbox");
const dynamodb_toolbox_constants_1 = require("./dynamodb-toolbox.constants");
let DynamoDBToolboxCoreModule = DynamoDBToolboxCoreModule_1 = class DynamoDBToolboxCoreModule {
    static forRoot(options) {
        const provider = {
            provide: dynamodb_toolbox_constants_1.DYNAMODB_TABLE,
            useFactory: () => new dynamodb_toolbox_1.Table(options)
        };
        return {
            module: DynamoDBToolboxCoreModule_1,
            providers: [provider],
            exports: [provider],
        };
    }
    static forRootAsync(options) {
        const provider = {
            provide: dynamodb_toolbox_constants_1.DYNAMODB_TABLE,
            useFactory: (options) => new dynamodb_toolbox_1.Table(options),
            inject: [dynamodb_toolbox_constants_1.DYNAMODB_OPTIONS],
        };
        const asyncProviders = this.createAsyncProviders(options);
        return {
            module: DynamoDBToolboxCoreModule_1,
            imports: options.imports,
            providers: [...asyncProviders, provider],
            exports: [provider],
        };
    }
    static createAsyncProviders(options) {
        if (options.useExisting || options.useFactory) {
            return [this.createAsyncOptionsProvider(options)];
        }
        const useClass = options.useClass;
        return [
            this.createAsyncOptionsProvider(options),
            {
                provide: useClass,
                useClass,
            },
        ];
    }
    static createAsyncOptionsProvider(options) {
        if (options.useFactory) {
            return {
                provide: dynamodb_toolbox_constants_1.DYNAMODB_OPTIONS,
                useFactory: options.useFactory,
                inject: options.inject || [],
            };
        }
        const inject = [
            (options.useClass ||
                options.useExisting),
        ];
        return {
            provide: dynamodb_toolbox_constants_1.DYNAMODB_OPTIONS,
            useFactory: async (optionsFactory) => await optionsFactory.createDynamooseOptions(),
            inject,
        };
    }
};
DynamoDBToolboxCoreModule = DynamoDBToolboxCoreModule_1 = __decorate([
    (0, common_1.Global)(),
    (0, common_1.Module)({})
], DynamoDBToolboxCoreModule);
exports.DynamoDBToolboxCoreModule = DynamoDBToolboxCoreModule;
